using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.Security.Entity
 {
    [TypeScript]
    [Table("security_permission_view")]
    public class SecurityPermissionViewEntity : ViewEntityBase
    {

    public SecurityPermissionViewEntity() 
    {
    }

    [Column("permission_name")]
    public string PermissionName  { get; set; }
    [Column("function_name")]
    public string? FunctionName  { get; set; }
    [Column("description")]
    public string? Description  { get; set; }
    [Column("created_datetime")]
    public DateTime CreatedDatetime  { get; set; }
    [Column("dependent")]
    public string? Dependent  { get; set; }

    public const string PERMISSION_NAME = "PermissionName";
    public const string FUNCTION_NAME = "FunctionName";
    public const string DESCRIPTION = "Description";
    public const string CREATED_DATETIME = "CreatedDatetime";
    public const string DEPENDENT = "Dependent";

    public const string DB_NAME_SECURITY_PERMISSION_VIEW = "security_permission_view";
    public const string DB_NAME_FIELDS="permission_name,function_name,description,created_datetime,dependent";

    public const string DB_PERMISSION_NAME = "permission_name";
    public const string DB_FUNCTION_NAME = "function_name";
    public const string DB_DESCRIPTION = "description";
    public const string DB_CREATED_DATETIME = "created_datetime";
    public const string DB_DEPENDENT = "dependent";


    public static SecurityPermissionViewEntity GetInstance()
    {
        return new SecurityPermissionViewEntity();
    }

    public virtual void CopyFrom(SecurityPermissionViewEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(SecurityPermissionViewEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.PermissionName =  source.PermissionName;
        this.FunctionName =  source.FunctionName;
        this.Description =  source.Description;
        this.CreatedDatetime =  source.CreatedDatetime;
        this.Dependent =  source.Dependent;

        if (includeSystemFields)
        {
        this.CreatedDatetime =  source.CreatedDatetime;
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_SECURITY_PERMISSION_VIEW}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_SECURITY_PERMISSION_VIEW}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
		
        if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_PERMISSION_NAME ;  		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_SECURITY_PERMISSION_VIEW}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public SecurityPermissionViewEntity Clone()
    {
        SecurityPermissionViewEntity result = new SecurityPermissionViewEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
